/**
 *	@file	?.cpp
 *	@brief
 *	@author	tenk*
 *	@date	200?-??
 *	@note
 *		ႢR}hCc[p̐`.
 */

//#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>

#include "../ExArgv.h"


const char*	 g_ttl = "test";
unsigned	 g_fileNum;
unsigned	 g_optNum;
unsigned	 g_optCount;


/** g.
 */
static int usage()
{
	fprintf(stderr, "usage>test [-opts] file(s)\n"
		   "  -?    ̃wv\n"
		   "  -tNAME  eXg\n"
		   "  -fN     ׂt@C\n"
		   "  -oN     ׂIvV\n"
		  );
	return 0;
}



/** IvV̏.
 */
int option(const char* arg)
{
	const char* p = arg + 1;
	switch (*p) {
	case '?':
		usage();
		break;

	case 't':
		g_ttl	  = p+1;
		break;

	case 'f':
		g_fileNum = strtol(p+1,0,0);
		break;

	case 'o':
		g_optNum  = strtol(p+1,0,0);
		break;

	default:
		;	// fprintf(stderr, "bad option '%s'", arg);
	}
	++g_optCount;
	return 1;
}



/** C.
 */
int main(int argc, char* argv[])
{
	int		 i;
	unsigned fileCount = 0;
	int		 f;

	ExArgv_conv(&argc, &argv);

	if (argc < 2)
		return usage();

	g_ttl = argv[0];

	// IvV擾.
	for (i = 1; i < argc; ++i) {
		if (argv[i][0] == '-') {
			option(argv[i]);
		}
	}

	// t@C擾.
	for (i = 0; i < argc; ++i) {
		const char* p = argv[i];
		if (*p != '-') {
			printf("%s\n", p);
			++fileCount;
		}
	}
	--fileCount;
	printf("\n");

	f = (g_optCount==g_optNum && fileCount==g_fileNum);
	fprintf(stderr, "%-24s  opt=%3d  file=%5d  %s\n", g_ttl, g_optCount, fileCount, f ? "[OK]" : "*NG*");
	if (f == 0) {
		fprintf(stderr, "\t\t\t [opt=%3d  file=%5d]\n", g_optNum, g_fileNum);
	}
	return 0;
}
