/**
 *	@file 	ExArgv.h
 *	@brief	argc,argv̊g(ChJ[h,X|Xt@C).
 *	@author	tenk* (Masashi Kitamura)
 *	@date	2006-2010
 *	@note
 *	-	main(int argc,char* argv[]) argc,argvɑ΂A
 *		ChJ[hw⃌X|Xt@Cw蓙WJargc,argvɕϊ.
 *		main()̏[炢 ExArgv_conv(&argc, &argv); ̂悤ɌĂяo.
 *		邢 WinMain() ł, ExArgv_forWinMain(cmdl, &argc, &argv);
 *
 *	-	Cdos/winn(̃R}hCc[)z.
 *		ꉞ linux gccł̃RpC.
 *		(unixnƃChJ[h̓VFC낤ŁAbgȂ)
 *
 *	-	ExArgv.h́Aꉞwb_AExArgv.c ̐ݒt@Cł.
 *		AvƂ ExArgv.h ExArgv.c Rs[āAExArgv.h
 *		JX^Ďĝz.
 *	-	ݒłvf́A
 *			- ChJ[h (on/off)
 *			- ChJ[h̍ċAw(**)̗L (on/off)
 *			- @X|Xt@C (on/off)
 *			- .exeA .cfg t@C Ǎ (on/off)
 *			- IvVϐ̗p
 *			
 *
 *	-	̐擪'-'Ȃ΃IvV낤ŁA̕񒆂
 *		ChJ[hĂWJȂ.
 *	-	}N UNICODE `Ă΁Awchar_tpAłȂcharp.
 *	-	_WIN32 `Ă winpAłȂ unixnz.
 *
 *	- Public Domain Software
 */

#ifndef EXARGV_INCLUDED
#define EXARGV_INCLUDED

// ---------------------------------------------------------------------------
// ݒ.

//[] ChJ[hw 1=L  0=  `=ftHgݒ(1)
//#define EXARGV_USE_WC			1


//[] ChJ[honɁAChJ[h ** ΍ċA
//	 	1= 0=Ȃ `=ftHgݒ(1)
//#define EXARGV_USE_WC_REC		1


//[] @X|Xt@C
//		1=L	 0=  `=ftHgݒ(1)
//#define EXARGV_USE_RESFILE	1


//[] ȈՃRtBO(X|X)t@C͂
//		1=L	0=	`=ftHg(0)
//	 ĹAwin/dosȂ .exe  .cfg ɒupX.
//			   ȊOȂ unix n낤 ~/.st@C.cfg
//#define EXARGV_USE_CONFIG		0


//[] RtBOt@C͗L̂ƂA`΁A
//		RtBOt@C̊gqɂ.
//#define EXARGV_CONFIG_EXT		".cfg"	// .conf


//[] `ƁA̖O̊ϐR}hCƂėp.
//#define EXARGV_ENVNAME	"your_app_env_name"


//[] win̂. argv[0] ̎st@CtpX
//		1=L	0=		`=ftHg(1)
//	 bcc,dmc,watcom͌tpXȂ̂ŉ܂. ̂vc,gcc.
//#define EXARGV_USE_FULLPATH_ARGV0


//[] `΁AfilePath \  / ɒu.
//#define EXARGV_TOSLASH


//[] `΁AfilePath /  \ ɒu.
//#define EXARGV_TOBACKSLASH


//[] `΁A/ IvVJnƂ݂Ȃ.
//#define EXARGV_USE_SLASH_OPT


//[] . VĈ. `ƁAsetargv̑piƂăRpC(ExArgv_get͖)
//	  setargv.obj ̃NKv.
// #define EXARGV_USE_SETARGV



// ---------------------------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif


#if defined EXARGV_USE_SETARGV	// VC̈Öُ̒up.

#elif defined _WINDOWS		// win-gui p.
 #if defined UNICODE
  void ExArgv_forWinMain(const wchar_t* pCmdLine, int* pArgc, wchar_t*** pppArgv);
 #else
  void ExArgv_forWinMain(const char* 	pCmdLine, int* pArgc, char***	 pppArgv);
 #endif
#else						// R}hCc[p. main̏[炢ɌĂԂ̂z.
 #if defined UNICODE
  void ExArgv_conv(int* pArgc, wchar_t*** pppArgv);
 #else
  void ExArgv_conv(int* pArgc, char*** pppArgv);
 #endif
#endif


#ifdef __cplusplus
}
#endif
// ---------------------------------------------------------------------------
#endif	// EXARGV_H
